/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of acpi-tmp/ssdt12.dat, Wed Nov 27 14:35:42 2019
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001B7C (7036)
 *     Revision         0x01
 *     Checksum         0xCB
 *     OEM ID           "LENOVO"
 *     OEM Table ID     "NvOptTbl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20160527 (538314023)
 */
DefinitionBlock ("", "SSDT", 1, "LENOVO", "NvOptTbl", 0x00001000)
{
    External (_SB_.CPPC, IntObj)
    External (_SB_.GGIV, MethodObj)    // 1 Arguments
    External (_SB_.HWPV, IntObj)
    External (_SB_.PCI0, DeviceObj)
    External (_SB_.PCI0.CED0, IntObj)
    External (_SB_.PCI0.GFX0, DeviceObj)
    External (_SB_.PCI0.LMS0, IntObj)
    External (_SB_.PCI0.LPCB.EC__.AC__._PSR, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.LPCB.EC__.BRTD, PkgObj)
    External (_SB_.PCI0.LPCB.EC__.HKEY.ANGN, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.HKEY.GPTL, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.HKEY.LDST, UnknownObj)
    External (_SB_.PCI0.LPCB.EC__.HKEY.NVSD, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.LPCB.EC__.TMP0, UnknownObj)
    External (_SB_.PCI0.P0AP, IntObj)
    External (_SB_.PCI0.P0CM, IntObj)
    External (_SB_.PCI0.P0LD, IntObj)
    External (_SB_.PCI0.P0LS, IntObj)
    External (_SB_.PCI0.P0PM, IntObj)
    External (_SB_.PCI0.P0RM, IntObj)
    External (_SB_.PCI0.PEG0, DeviceObj)
    External (_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (_SB_.PCI0.PEG0.PEGP._OFF, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.PEG0.PEGP._ON_, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.PEG0.PEGP._STA, MethodObj)    // 0 Arguments
    External (_SB_.PCI0.PGOF, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.PGON, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.RTDS, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.RTEN, MethodObj)    // 1 Arguments
    External (_SB_.PCI0.S0DI, IntObj)
    External (_SB_.PCI0.S0VI, IntObj)
    External (_SB_.PCI0.SBN0, FieldUnitObj)
    External (_SB_.PCI0.SGPO, MethodObj)    // 5 Arguments
    External (_SB_.PCI0.SVIW, IntObj)
    External (_SB_.PR00._PSS, IntObj)
    External (_SB_.SKOF, UnknownObj)
    External (ADBG, MethodObj)    // 1 Arguments
    External (BNTN, UnknownObj)
    External (D0DI, UnknownObj)
    External (DNPF, UnknownObj)
    External (HRA0, UnknownObj)
    External (HRE0, UnknownObj)
    External (HRG0, UnknownObj)
    External (IGDS, UnknownObj)
    External (LMS0, IntObj)
    External (NPBF, UnknownObj)
    External (NVGA, UnknownObj)
    External (OSYS, IntObj)
    External (PBID, UnknownObj)
    External (PNOT, MethodObj)    // 1 Arguments
    External (S0DI, IntObj)
    External (S0VI, IntObj)
    External (SGGP, UnknownObj)
    External (VEDI, UnknownObj)
    External (VEDX, UnknownObj)
    External (VIGD, UnknownObj)
    External (XBAS, UnknownObj)

    Scope (\_SB.PCI0)
    {
        Name (OTM, "OTMACPI 2010-Mar-09 12:08:26")
    }

    Scope (\_SB.PCI0.PEG0)
    {
        Device (PEGA)
        {
            Name (_ADR, One)  // _ADR: Address
        }

        OperationRegion (PG0X, SystemMemory, (\XBAS + 0x00100000), 0x0500)
        Field (PG0X, DWordAcc, Lock, Preserve)
        {
            Offset (0x04), 
            CMDR,   8, 
            Offset (0x40), 
            NIDR,   32, 
            Offset (0x488), 
                ,   25, 
            MLTR,   1
        }

        Method (MSOF, 0, NotSerialized)
        {
        }

        Method (MSON, 0, NotSerialized)
        {
        }

        Method (DGOF, 0, NotSerialized)
        {
        }

        Method (DGON, 0, NotSerialized)
        {
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (GOBT, 1, NotSerialized)
        {
            Name (OPVK, Buffer (0xE2)
            {
                /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0018 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0020 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0028 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0030 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0038 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0040 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0048 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0050 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0058 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0060 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0068 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0070 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0078 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0080 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0088 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0090 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 0098 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00A0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00A8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00B0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00B8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00C0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00C8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00D0 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00D8 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                /* 00E0 */  0x00, 0x00                                       // ..
            })
            CreateWordField (Arg0, 0x02, USRG)
            If ((USRG == 0x564B))
            {
                Return (OPVK) /* \_SB_.PCI0.PEG0.PEGP.GOBT.OPVK */
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (OMPR, 0x02)
        Name (GPRF, Zero)
        Method (NVOP, 4, Serialized)
        {
            If ((Arg1 != 0x0100))
            {
                Return (0x80000001)
            }

            Switch (ToInteger (Arg2))
            {
                Case (Zero)
                {
                    Local0 = Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                           // ....
                        }
                    Divide (Zero, 0x08, Local2, Local1)
                    Local2 = (One << Local2)
                    Local0 [Local1] = (DerefOf (Local0 [Local1]) | Local2)
                    Divide (0x1A, 0x08, Local2, Local1)
                    Local2 = (One << Local2)
                    Local0 [Local1] = (DerefOf (Local0 [Local1]) | Local2)
                    Divide (0x1B, 0x08, Local2, Local1)
                    Local2 = (One << Local2)
                    Local0 [Local1] = (DerefOf (Local0 [Local1]) | Local2)
                    Return (Local0)
                }
                Case (0x1A)
                {
                    CreateField (Arg3, 0x18, 0x02, OPCE)
                    CreateField (Arg3, Zero, One, FLCH)
                    CreateField (Arg3, One, One, DVSR)
                    CreateField (Arg3, 0x02, One, DVSC)
                    If (ToInteger (FLCH))
                    {
                        OMPR = OPCE /* \_SB_.PCI0.PEG0.PEGP.NVOP.OPCE */
                    }

                    Local0 = Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                           // ....
                        }
                    CreateField (Local0, Zero, One, OPEN)
                    CreateField (Local0, 0x03, 0x02, CGCS)
                    CreateField (Local0, 0x06, One, SHPC)
                    CreateField (Local0, 0x08, One, SNSR)
                    CreateField (Local0, 0x18, 0x03, DGPC)
                    CreateField (Local0, 0x1B, 0x02, HDAC)
                    OPEN = One
                    SHPC = One
                    HDAC = 0x03
                    If (ToInteger (DVSC))
                    {
                        If (ToInteger (DVSR))
                        {
                            GPRF = One
                        }
                        Else
                        {
                            GPRF = Zero
                        }
                    }

                    SNSR = GPRF /* \_SB_.PCI0.PEG0.PEGP.GPRF */
                    DGPC = One
                    If (\_SB.PCI0.PEG0.PEGP._STA ())
                    {
                        CGCS = 0x03
                    }

                    Return (Local0)
                }
                Case (0x1B)
                {
                    Local0 = Arg3
                    CreateField (Local0, Zero, One, OPFL)
                    CreateField (Local0, One, One, OPVL)
                    Local1 = Zero
                    Local1 = MLTR /* \_SB_.PCI0.PEG0.MLTR */
                    Return (Local1)
                }
                Case (0x10)
                {
                    Return (0x80000001)
                }

            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (TGPC, Buffer (0x04)
        {
             0x00                                             // .
        })
        Name (GC6M, Zero)
        Name (TDGC, Zero)
        Name (DGCX, Zero)
        Name (TRPC, Zero)
        Name (GPFE, 0xFD6A0880)
        Name (GPGE, 0xFD6A0890)
        OperationRegion (GCGE, SystemMemory, GPGE, 0x10)
        Field (GCGE, AnyAcc, NoLock, Preserve)
        {
            GETX,   1, 
            GERX,   1, 
            Offset (0x01), 
            GETD,   1, 
            GERD,   1, 
            GEPM,   2
        }

        OperationRegion (GCFE, SystemMemory, GPFE, 0x10)
        Field (GCFE, AnyAcc, NoLock, Preserve)
        {
            FETX,   1, 
            FERX,   1, 
            Offset (0x01), 
            FETD,   1, 
            FERD,   1, 
            FEPM,   2
        }

        Name (FBTO, 0x03)
        Mutex (LG6O, 0x00)
        Method (GC6I, 0, Serialized)
        {
            Acquire (LG6O, 0xFFFF)
            Sleep (0x0A)
            LTES = \_SB.PCI0.LMS0 /* External reference */
            If ((N18X == One))
            {
                \_SB.PCI0.RTDS (Zero)
                Sleep (0x0A)
                \_SB.PCI0.SGPO (SGGP, HRE0, HRG0, HRA0, One)
            }
            Else
            {
                \_SB.PCI0.P0LD = One
                While ((\_SB.PCI0.P0LS != Zero))
                {
                    Sleep (One)
                }

                Local0 = Zero
                While ((Local0 < FBTO))
                {
                    If ((ToInteger (FERX) == One))
                    {
                        Break
                    }

                    Sleep (One)
                    Local0 += One
                }

                \_SB.PCI0.P0RM = One
                \_SB.PCI0.P0AP = 0x03
            }

            GC6M = One
            Release (LG6O)
        }

        Method (GC6O, 0, Serialized)
        {
            Acquire (LG6O, 0xFFFF)
            If ((N18X == One))
            {
                \_SB.PCI0.SGPO (SGGP, HRE0, HRG0, HRA0, Zero)
                Sleep (0x0A)
                \_SB.PCI0.RTEN (Zero)
                Sleep (One)
            }
            Else
            {
                \_SB.PCI0.P0AP = Zero
                \_SB.PCI0.P0RM = Zero
                \_SB.PCI0.P0LD = Zero
                GETX = Zero
                While ((ToInteger (FERX) != Zero))
                {
                    Stall (0x64)
                }

                GETX = One
            }

            While ((\_SB.PCI0.P0LS < 0x03))
            {
                Sleep (One)
            }

            \_SB.PCI0.P0CM |= 0x04
            \_SB.PCI0.LMS0 = LTES /* \_SB_.PCI0.PEG0.PEGP.LTES */
            \_SB.PCI0.CED0 = One
            GC6M = Zero
            Release (LG6O)
        }

        Method (GETS, 0, Serialized)
        {
            If ((GC6M == Zero))
            {
                Return (One)
            }
            ElseIf ((GC6M == One))
            {
                Return (0x03)
            }
        }

        Method (NGC6, 4, Serialized)
        {
            If ((Arg1 < 0x0100))
            {
                Return (0x80000001)
            }

            Switch (ToInteger (Arg2))
            {
                Case (Zero)
                {
                    Return (Buffer (0x04)
                    {
                         0x1B, 0x00, 0x00, 0x00                           // ....
                    })
                }
                Case (One)
                {
                    Name (JTB1, Buffer (0x04)
                    {
                         0x00                                             // .
                    })
                    CreateField (JTB1, Zero, One, JTEN)
                    CreateField (JTB1, One, 0x02, SREN)
                    CreateField (JTB1, 0x03, 0x03, PLPR)
                    CreateField (JTB1, 0x06, 0x02, FBPR)
                    CreateField (JTB1, 0x08, 0x02, GUPR)
                    CreateField (JTB1, 0x0A, One, GC6R)
                    CreateField (JTB1, 0x0B, One, PTRH)
                    CreateField (JTB1, 0x0D, One, MHYB)
                    CreateField (JTB1, 0x0E, One, RPCL)
                    CreateField (JTB1, 0x0F, 0x02, GC6V)
                    CreateField (JTB1, 0x14, 0x0C, JTRV)
                    JTEN = One
                    GC6R = Zero
                    MHYB = One
                    RPCL = One
                    If ((ToInteger (RPCL) == One))
                    {
                        TRPC = One
                    }

                    If ((N18X == One))
                    {
                        GC6V = 0x02
                        JTRV = 0x0200
                    }
                    Else
                    {
                        GC6V = One
                        JTRV = 0x0103
                    }

                    PTRH = One
                    SREN = One
                    Return (JTB1) /* \_SB_.PCI0.PEG0.PEGP.NGC6.JTB1 */
                }
                Case (0x02)
                {
                    Return (Arg3)
                }
                Case (0x03)
                {
                    CreateField (Arg3, Zero, 0x03, GUPC)
                    CreateField (Arg3, 0x04, One, PLPC)
                    CreateField (Arg3, 0x0E, 0x02, DFGC)
                    CreateField (Arg3, 0x10, 0x03, GPCX)
                    TGPC = Arg3
                    If (((ToInteger (GUPC) != Zero) || (ToInteger (DFGC
                        ) != Zero)))
                    {
                        TDGC = ToInteger (DFGC)
                        DGCX = ToInteger (GPCX)
                    }

                    Name (JTB3, Buffer (0x04)
                    {
                         0x00                                             // .
                    })
                    CreateField (JTB3, Zero, 0x03, GUPS)
                    CreateField (JTB3, 0x03, One, GPGS)
                    CreateField (JTB3, 0x07, One, PLST)
                    If ((ToInteger (DFGC) != Zero))
                    {
                        GPGS = One
                        GUPS = One
                        Return (JTB3) /* \_SB_.PCI0.PEG0.PEGP.NGC6.JTB3 */
                    }

                    If ((ToInteger (GUPC) == One))
                    {
                        GC6I ()
                        PLST = One
                        GUPS = Zero
                    }
                    ElseIf ((ToInteger (GUPC) == 0x02))
                    {
                        GC6I ()
                        If ((ToInteger (PLPC) == Zero))
                        {
                            PLST = Zero
                        }

                        GUPS = Zero
                    }
                    ElseIf ((ToInteger (GUPC) == 0x03))
                    {
                        GC6O ()
                        If ((ToInteger (PLPC) != Zero))
                        {
                            PLST = Zero
                        }

                        GPGS = One
                        GUPS = Zero
                    }
                    ElseIf ((ToInteger (GUPC) == 0x04))
                    {
                        GC6O ()
                        If ((ToInteger (PLPC) != Zero))
                        {
                            PLST = Zero
                        }

                        GPGS = One
                        GUPS = Zero
                    }
                    ElseIf ((ToInteger (GUPC) == Zero))
                    {
                        GUPS = GETS ()
                        If ((ToInteger (GUPS) == One))
                        {
                            GPGS = One
                        }
                        Else
                        {
                            GPGS = Zero
                        }
                    }
                    ElseIf ((ToInteger (GUPC) == 0x06)){}
                    Return (JTB3) /* \_SB_.PCI0.PEG0.PEGP.NGC6.JTB3 */
                }
                Case (0x04)
                {
                    Name (JTB4, Buffer (0x04)
                    {
                         0x00                                             // .
                    })
                    CreateField (Arg3, 0x03, One, AZDM)
                    CreateField (Arg3, 0x02, One, AZUD)
                    CreateField (JTB4, 0x02, One, AUDR)
                    AUDR = MLTR /* \_SB_.PCI0.PEG0.MLTR */
                    Return (JTB4) /* \_SB_.PCI0.PEG0.PEGP.NGC6.JTB4 */
                }

            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (DGOS, Zero)
        Name (OTMS, Zero)
        OperationRegion (VGAR, SystemMemory, (XBAS + (SBN0 << 0x14)), 0x0100)
        Field (VGAR, DWordAcc, NoLock, Preserve)
        {
            VREG,   2048
        }

        Name (VGAB, Buffer (0x0100)
        {
             0x00                                             // .
        })
        OperationRegion (PCNV, PCI_Config, 0x0488, 0x04)
        Field (PCNV, AnyAcc, NoLock, Preserve)
        {
                ,   25, 
            MLTF,   1
        }

        Method (_STA, 0, NotSerialized)  // _STA: Status
        {
            Return (0x0F)
        }

        Method (_ON, 0, Serialized)  // _ON_: Power On
        {
            \_SB.PCI0.PGON (Zero)
            If ((GPRF != One))
            {
                VREG = VGAB /* \_SB_.PCI0.PEG0.PEGP.VGAB */
            }
        }

        Method (_OFF, 0, Serialized)  // _OFF: Power Off
        {
            If ((GPRF != One))
            {
                VGAB = VREG /* \_SB_.PCI0.PEG0.PEGP.VREG */
            }

            \_SB.PCI0.PGOF (Zero)
        }

        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
            If (DGOS)
            {
                \_SB.PCI0.PEG0.PEGP._ON ()
                DGOS = Zero
                OTMS = Zero
            }
        }

        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
            If ((\_SB.PCI0.PEG0.PEGP.OMPR == 0x03))
            {
                OTMS = One
                \_SB.PCI0.PEG0.PEGP._OFF ()
                DGOS = One
                \_SB.PCI0.PEG0.PEGP.OMPR = 0x02
            }
        }

        Method (NVST, 0, NotSerialized)
        {
            Notify (\_SB.PCI0.PEG0.PEGP, 0xC0) // Hardware-Specific
        }

        Name (NVVI, Zero)
        Name (NVSI, Zero)
        Name (LTES, Zero)
        Name (N18X, One)
        OperationRegion (PER2, PCI_Config, 0x88, 0x04)
        Field (PER2, DWordAcc, NoLock, Preserve)
        {
            ASPM,   2
        }

        Method (MASP, 1, NotSerialized)
        {
            ASPM = Arg0
        }

        Method (_INI, 0, NotSerialized)  // _INI: Initialize
        {
            NVVI = S0VI /* External reference */
            NVSI = S0DI /* External reference */
            If ((D0DI == 0x1CBD))
            {
                N18X = Zero
            }

            If (\VIGD)
            {
                MASP (One)
            }
            ElseIf ((\_SB.PCI0.LPCB.EC.AC._PSR () == One))
            {
                MASP (Zero)
            }
            Else
            {
                MASP (One)
            }
        }

        Method (NVPO, 0, NotSerialized)
        {
            While ((\_SB.PCI0.P0LS < 0x03))
            {
                Sleep (One)
            }

            \_SB.PCI0.P0CM = 0x07
            \_SB.PCI0.P0PM = Zero
            Sleep (0x0A)
            SVIW = ((NVSI << 0x10) | NVVI)
            LMS0 = LTES /* \_SB_.PCI0.PEG0.PEGP.LTES */
            CED0 = One
        }

        Method (NVPF, 0, NotSerialized)
        {
            LTES = LMS0 /* External reference */
        }

        Device (LCD0)
        {
            Method (_ADR, 0, NotSerialized)  // _ADR: Address
            {
                Return (0x8000A450)
            }

            Method (_BCL, 0, NotSerialized)  // _BCL: Brightness Control Levels
            {
                If ((OSYS >= 0x07DC))
                {
                    Return (Package (0x67)
                    {
                        0x50, 
                        0x32, 
                        Zero, 
                        One, 
                        0x02, 
                        0x03, 
                        0x04, 
                        0x05, 
                        0x06, 
                        0x07, 
                        0x08, 
                        0x09, 
                        0x0A, 
                        0x0B, 
                        0x0C, 
                        0x0D, 
                        0x0E, 
                        0x0F, 
                        0x10, 
                        0x11, 
                        0x12, 
                        0x13, 
                        0x14, 
                        0x15, 
                        0x16, 
                        0x17, 
                        0x18, 
                        0x19, 
                        0x1A, 
                        0x1B, 
                        0x1C, 
                        0x1D, 
                        0x1E, 
                        0x1F, 
                        0x20, 
                        0x21, 
                        0x22, 
                        0x23, 
                        0x24, 
                        0x25, 
                        0x26, 
                        0x27, 
                        0x28, 
                        0x29, 
                        0x2A, 
                        0x2B, 
                        0x2C, 
                        0x2D, 
                        0x2E, 
                        0x2F, 
                        0x30, 
                        0x31, 
                        0x32, 
                        0x33, 
                        0x34, 
                        0x35, 
                        0x36, 
                        0x37, 
                        0x38, 
                        0x39, 
                        0x3A, 
                        0x3B, 
                        0x3C, 
                        0x3D, 
                        0x3E, 
                        0x3F, 
                        0x40, 
                        0x41, 
                        0x42, 
                        0x43, 
                        0x44, 
                        0x45, 
                        0x46, 
                        0x47, 
                        0x48, 
                        0x49, 
                        0x4A, 
                        0x4B, 
                        0x4C, 
                        0x4D, 
                        0x4E, 
                        0x4F, 
                        0x50, 
                        0x51, 
                        0x52, 
                        0x53, 
                        0x54, 
                        0x55, 
                        0x56, 
                        0x57, 
                        0x58, 
                        0x59, 
                        0x5A, 
                        0x5B, 
                        0x5C, 
                        0x5D, 
                        0x5E, 
                        0x5F, 
                        0x60, 
                        0x61, 
                        0x62, 
                        0x63, 
                        0x64
                    })
                }

                Return (Package (0x12)
                {
                    0x64, 
                    0x33, 
                    Zero, 
                    One, 
                    0x03, 
                    0x05, 
                    0x07, 
                    0x09, 
                    0x0B, 
                    0x0E, 
                    0x12, 
                    0x16, 
                    0x1C, 
                    0x24, 
                    0x33, 
                    0x46, 
                    0x59, 
                    0x64
                })
            }

            Method (_DDC, 1, NotSerialized)  // _DDC: Display Data Current
            {
                If (\VIGD)
                {
                    Return (Zero)
                }

                Name (VBUF, Buffer (0x0100)
                {
                     0x00                                             // .
                })
                Concatenate (VEDI, VEDX, VBUF) /* \_SB_.PCI0.PEG0.PEGP.LCD0._DDC.VBUF */
                Return (VBUF) /* \_SB_.PCI0.PEG0.PEGP.LCD0._DDC.VBUF */
            }
        }

        Device (DP0)
        {
            Method (_ADR, 0, NotSerialized)  // _ADR: Address
            {
                Return (0x80006340)
            }
        }

        Method (_DOD, 0, NotSerialized)  // _DOD: Display Output Devices
        {
            If (IGDS)
            {
                Return (Package (0x01)
                {
                    0x80006340
                })
            }
            Else
            {
                Return (Package (0x02)
                {
                    0x8000A450, 
                    0x80006340
                })
            }
        }

        Method (NBCI, 4, Serialized)
        {
            If ((Arg1 == 0x0102))
            {
                If ((Arg2 == Zero))
                {
                    If ((N18X == One))
                    {
                        Return (0x00110001)
                    }
                    Else
                    {
                        Return (0x00100001)
                    }
                }

                If ((Arg2 == 0x10))
                {
                    Name (RTDR, Buffer (0xA1)
                    {
                        /* 0000 */  0x57, 0x74, 0xDC, 0x86, 0x75, 0x84, 0xEC, 0xE7,  // Wt..u...
                        /* 0008 */  0x52, 0x44, 0xA1, 0x00, 0x00, 0x00, 0x00, 0x01,  // RD......
                        /* 0010 */  0x00, 0x00, 0x00, 0x00, 0xDE, 0x10, 0x00, 0x00,  // ........
                        /* 0018 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                        /* 0020 */  0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x34, 0x00,  // ......4.
                        /* 0028 */  0x00, 0x00, 0x01, 0x00, 0x47, 0x00, 0x00, 0x00,  // ....G...
                        /* 0030 */  0x02, 0x00, 0x45, 0x00, 0x00, 0x00, 0x03, 0x00,  // ..E.....
                        /* 0038 */  0x51, 0x00, 0x00, 0x00, 0x04, 0x00, 0x4F, 0x00,  // Q.....O.
                        /* 0040 */  0x00, 0x00, 0x05, 0x00, 0x4D, 0x00, 0x00, 0x00,  // ....M...
                        /* 0048 */  0x06, 0x00, 0x4B, 0x00, 0x00, 0x00, 0x07, 0x00,  // ..K.....
                        /* 0050 */  0x49, 0x00, 0x00, 0x00, 0x08, 0x00, 0x47, 0x00,  // I.....G.
                        /* 0058 */  0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0xD9, 0x1C,  // ........
                        /* 0060 */  0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,  // ........
                        /* 0068 */  0x41, 0x5D, 0xC9, 0x00, 0x01, 0x24, 0x2E, 0x00,  // A]...$..
                        /* 0070 */  0x02, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x01,  // ........
                        /* 0078 */  0x00, 0x00, 0x00, 0xD9, 0x1C, 0x04, 0x00, 0x00,  // ........
                        /* 0080 */  0x00, 0x01, 0x00, 0x00, 0x00, 0x60, 0x68, 0x9E,  // .....`h.
                        /* 0088 */  0x35, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // 5.......
                        /* 0090 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                        /* 0098 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                        /* 00A0 */  0x00                                             // .
                    })
                    CreateWordField (Arg3, 0x02, USAG)
                    If ((USAG == 0x4452))
                    {
                        Return (RTDR) /* \_SB_.PCI0.PEG0.PEGP.NBCI.RTDR */
                    }

                    Return (Zero)
                }

                If ((Arg2 == 0x14))
                {
                    Local0 = Package (0x07)
                        {
                            0x8000A450, 
                            0x0100, 
                            Zero, 
                            Zero, 
                            0x05, 
                            One, 
                            Package (0x04)
                            {
                                0xDC, 
                                Zero, 
                                0x03E8, 
                                Package (0x03)
                                {
                                    0x65, 
                                    Package (0x65)
                                    {
                                        Zero, 
                                        0x0A, 
                                        0x14, 
                                        0x1E, 
                                        0x28, 
                                        0x32, 
                                        0x3C, 
                                        0x46, 
                                        0x50, 
                                        0x5A, 
                                        0x64, 
                                        0x6E, 
                                        0x78, 
                                        0x82, 
                                        0x8C, 
                                        0x96, 
                                        0xA0, 
                                        0xAA, 
                                        0xB4, 
                                        0xBE, 
                                        0xC8, 
                                        0xD2, 
                                        0xDC, 
                                        0xE6, 
                                        0xF0, 
                                        0xFA, 
                                        0x0104, 
                                        0x010E, 
                                        0x0118, 
                                        0x0122, 
                                        0x012C, 
                                        0x0136, 
                                        0x0140, 
                                        0x014A, 
                                        0x0154, 
                                        0x015E, 
                                        0x0168, 
                                        0x0172, 
                                        0x017C, 
                                        0x0186, 
                                        0x0190, 
                                        0x019A, 
                                        0x01A4, 
                                        0x01AE, 
                                        0x01B8, 
                                        0x01C2, 
                                        0x01CC, 
                                        0x01D6, 
                                        0x01E0, 
                                        0x01EA, 
                                        0x01F4, 
                                        0x01FE, 
                                        0x0208, 
                                        0x0212, 
                                        0x021C, 
                                        0x0226, 
                                        0x0230, 
                                        0x023A, 
                                        0x0244, 
                                        0x024E, 
                                        0x0258, 
                                        0x0262, 
                                        0x026C, 
                                        0x0276, 
                                        0x0280, 
                                        0x028A, 
                                        0x0294, 
                                        0x029E, 
                                        0x02A8, 
                                        0x02B2, 
                                        0x02BC, 
                                        0x02C6, 
                                        0x02D0, 
                                        0x02DA, 
                                        0x02E4, 
                                        0x02EE, 
                                        0x02F8, 
                                        0x0302, 
                                        0x030C, 
                                        0x0316, 
                                        0x0320, 
                                        0x032A, 
                                        0x0334, 
                                        0x033E, 
                                        0x0348, 
                                        0x0352, 
                                        0x035C, 
                                        0x0366, 
                                        0x0370, 
                                        0x037A, 
                                        0x0384, 
                                        0x038E, 
                                        0x0398, 
                                        0x03A2, 
                                        0x03AC, 
                                        0x03B6, 
                                        0x03C0, 
                                        0x03CA, 
                                        0x03D4, 
                                        0x03DE, 
                                        0x03E8
                                    }, 

                                    Package (0x65)
                                    {
                                        Zero, 
                                        0x0A, 
                                        0x14, 
                                        0x1E, 
                                        0x28, 
                                        0x32, 
                                        0x3C, 
                                        0x46, 
                                        0x50, 
                                        0x5A, 
                                        0x64, 
                                        0x6E, 
                                        0x78, 
                                        0x82, 
                                        0x8C, 
                                        0x96, 
                                        0xA0, 
                                        0xAA, 
                                        0xB4, 
                                        0xBE, 
                                        0xC8, 
                                        0xD2, 
                                        0xDC, 
                                        0xE6, 
                                        0xF0, 
                                        0xFA, 
                                        0x0104, 
                                        0x010E, 
                                        0x0118, 
                                        0x0122, 
                                        0x012C, 
                                        0x0136, 
                                        0x0140, 
                                        0x014A, 
                                        0x0154, 
                                        0x015E, 
                                        0x0168, 
                                        0x0172, 
                                        0x017C, 
                                        0x0186, 
                                        0x0190, 
                                        0x019A, 
                                        0x01A4, 
                                        0x01AE, 
                                        0x01B8, 
                                        0x01C2, 
                                        0x01CC, 
                                        0x01D6, 
                                        0x01E0, 
                                        0x01EA, 
                                        0x01F4, 
                                        0x01FE, 
                                        0x0208, 
                                        0x0212, 
                                        0x021C, 
                                        0x0226, 
                                        0x0230, 
                                        0x023A, 
                                        0x0244, 
                                        0x024E, 
                                        0x0258, 
                                        0x0262, 
                                        0x026C, 
                                        0x0276, 
                                        0x0280, 
                                        0x028A, 
                                        0x0294, 
                                        0x029E, 
                                        0x02A8, 
                                        0x02B2, 
                                        0x02BC, 
                                        0x02C6, 
                                        0x02D0, 
                                        0x02DA, 
                                        0x02E4, 
                                        0x02EE, 
                                        0x02F8, 
                                        0x0302, 
                                        0x030C, 
                                        0x0316, 
                                        0x0320, 
                                        0x032A, 
                                        0x0334, 
                                        0x033E, 
                                        0x0348, 
                                        0x0352, 
                                        0x035C, 
                                        0x0366, 
                                        0x0370, 
                                        0x037A, 
                                        0x0384, 
                                        0x038E, 
                                        0x0398, 
                                        0x03A2, 
                                        0x03AC, 
                                        0x03B6, 
                                        0x03C0, 
                                        0x03CA, 
                                        0x03D4, 
                                        0x03DE, 
                                        0x03E8
                                    }
                                }
                            }
                        }
                    Local1 = Zero
                    While ((Local1 <= 0x64))
                    {
                        Local2 = DerefOf (DerefOf (\_SB.PCI0.LPCB.EC.BRTD [\BNTN]) [Local1])
                        Local2 *= 0x03E8
                        Divide (Local2, 0xFF, Local2, Local3)
                        DerefOf (DerefOf (DerefOf (Local0 [0x06]) [0x03]
                            ) [One]) [Local1] = Local3
                        Local1++
                    }

                    If ((OSYS >= 0x07D9))
                    {
                        If ((PBID == 0x05))
                        {
                            If ((\_SB.GGIV (0x0308000D) == Zero))
                            {
                                Local0 [One] = 0x0203
                            }
                            Else
                            {
                                Local0 [One] = 0x0200
                            }
                        }
                        Else
                        {
                            Local0 [One] = 0x0200
                        }
                    }

                    DerefOf (Local0 [0x06]) [Zero] = NPBF /* External reference */
                    DerefOf (Local0 [0x06]) [One] = 0x0C
                    Return (Local0)
                }
            }

            Return (0x80000002)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (CPUT, 0x32)
        Name (TGPU, Zero)
        Name (RQTC, Zero)
        Name (PSAP, Zero)
        Method (NVPS, 4, Serialized)
        {
            Switch (ToInteger (Arg2))
            {
                Case (Zero)
                {
                    Local0 = Buffer (0x08)
                        {
                             0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
                        }
                    If ((N18X == One))
                    {
                        Local3 = Buffer (0x08)
                            {
                                 0x00, 0x20, 0x2A, 0x13, 0xFF                     // . *..
                            }
                    }
                    Else
                    {
                        Local3 = Buffer (0x08)
                            {
                                 0x00, 0x20, 0x21, 0x22, 0x23, 0x2A, 0x13, 0xFF   // . !"#*..
                            }
                    }

                    Local4 = Zero
                    Local5 = DerefOf (Local3 [Local4])
                    While ((Local5 != 0xFF))
                    {
                        Divide (Local5, 0x08, Local2, Local1)
                        Local2 = (One << Local2)
                        Local0 [Local1] = (DerefOf (Local0 [Local1]) | Local2)
                        Local4++
                        Local5 = DerefOf (Local3 [Local4])
                    }

                    Return (Local0)
                }
                Case (0x13)
                {
                    Local0 = Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                           // ....
                        }
                    CreateField (Arg3, 0x02, One, PPST)
                    CreateBitField (Local0, 0x02, CPST)
                    If ((ToInteger (PPST) & (\_SB.PCI0.LPCB.EC.HKEY.ANGN == Zero)))
                    {
                        \_SB.PCI0.LPCB.EC.HKEY.ANGN = One
                        NVDN ()
                    }

                    CPST = One
                    Return (Local0)
                }
                Case (0x20)
                {
                    Local0 = Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                           // ....
                        }
                    CreateField (Local0, Zero, One, SPLU)
                    CreateField (Local0, 0x17, One, CPC2)
                    CreateField (Local0, 0x18, One, CUIT)
                    CreateField (Local0, 0x1E, One, PSER)
                    If ((N18X == One))
                    {
                        CUIT = Zero
                        PSER = Zero
                        CPC2 = Zero
                    }
                    Else
                    {
                        If ((\_SB.HWPV & 0x02))
                        {
                            CPC2 = One
                        }

                        CUIT = One
                        PSER = One
                    }

                    If (RQTC)
                    {
                        SPLU = One
                        RQTC = Zero
                    }

                    Return (Local0)
                }
                Case (0x21)
                {
                    Return (\_SB.PR00._PSS) /* External reference */
                }
                Case (0x22)
                {
                    CreateDWordField (Arg3, Zero, PCAP)
                    \_SB.CPPC = PCAP /* \_SB_.PCI0.PEG0.PEGP.NVPS.PCAP */
                    \PNOT (0x80)
                    PSAP = PCAP /* \_SB_.PCI0.PEG0.PEGP.NVPS.PCAP */
                    Return (PCAP) /* \_SB_.PCI0.PEG0.PEGP.NVPS.PCAP */
                }
                Case (0x23)
                {
                    Return (PSAP) /* \_SB_.PCI0.PEG0.PEGP.PSAP */
                }
                Case (0x2A)
                {
                    Local0 = Buffer (0x24)
                        {
                            /* 0000 */  0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,  // ........
                            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                            /* 0018 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                            /* 0020 */  0x00, 0x00, 0x00, 0x00                           // ....
                        }
                    Local0 [Zero] = DerefOf (Arg3 [Zero])
                    CreateField (Arg3, Zero, 0x04, QTYP)
                    Switch (ToInteger (QTYP))
                    {
                        Case (Zero)
                        {
                            CPUT = \_SB.PCI0.LPCB.EC.TMP0 /* External reference */
                            Local1 = CPUT /* \_SB_.PCI0.PEG0.PEGP.CPUT */
                            Local0 [0x0C] = (Local1 & 0xFF)
                            Return (Local0)
                        }
                        Case (One)
                        {
                            Local0 [0x0D] = 0x08
                            Local0 [One] = 0x03
                            Return (Local0)
                        }
                        Case (0x02)
                        {
                            Local0 [One] = 0x03
                            TGPU = \_SB.PCI0.LPCB.EC.HKEY.GPTL /* External reference */
                            Local0 [0x08] = TGPU /* \_SB_.PCI0.PEG0.PEGP.TGPU */
                            Return (Local0)
                        }

                    }
                }

            }

            Return (Buffer (0x04)
            {
                 0x02, 0x00, 0x00, 0x80                           // ....
            })
        }

        Method (NVDN, 0, NotSerialized)
        {
            ADBG ("NVDN Entry")
            ADBG (Concatenate ("ANGN =", ToHexString (\_SB.PCI0.LPCB.EC.HKEY.ANGN)))
            If ((\_SB.PCI0.LPCB.EC.HKEY.ANGN == One))
            {
                If ((\_SB.PCI0.LPCB.EC.AC._PSR () == One))
                {
                    Local1 = 0xD1
                }

                \_SB.PCI0.LPCB.EC.HKEY.ANGN = One
                If ((Local1 != \_SB.PCI0.LPCB.EC.HKEY.LDST))
                {
                    \_SB.PCI0.LPCB.EC.HKEY.NVSD (Local1)
                }

                DNPF = Zero
            }

            ADBG ("NVDN End")
        }
    }

    Scope (\)
    {
        Method (CMPB, 2, NotSerialized)
        {
            Local1 = SizeOf (Arg0)
            If ((Local1 != SizeOf (Arg1)))
            {
                Return (Zero)
            }

            Local0 = Zero
            While ((Local0 < Local1))
            {
                If ((DerefOf (Arg0 [Local0]) != DerefOf (Arg1 [Local0]
                    )))
                {
                    Return (Zero)
                }

                Local0++
            }

            Return (One)
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Method (MXMX, 1, Serialized)
        {
            If ((Arg0 == Zero))
            {
                Return (One)
            }

            If ((Arg0 == One))
            {
                Return (One)
            }

            If ((Arg0 == 0x02)){}
            Return (Zero)
        }

        Method (MXDS, 1, Serialized)
        {
            If ((Arg0 == Zero)){}
            If ((Arg0 == One)){}
            Return (Zero)
        }

        Name (MXM3, Buffer (0x66)
        {
            /* 0000 */  0x4D, 0x58, 0x4D, 0x5F, 0x03, 0x00, 0x5D, 0x00,  // MXM_..].
            /* 0008 */  0x30, 0x11, 0xB8, 0xFF, 0xF9, 0x3E, 0x00, 0x00,  // 0....>..
            /* 0010 */  0x00, 0x00, 0x0A, 0xF0, 0xF9, 0x3E, 0x00, 0x00,  // .....>..
            /* 0018 */  0x60, 0xE9, 0xD0, 0xFE, 0xF9, 0x3E, 0x00, 0x00,  // `....>..
            /* 0020 */  0x60, 0x6A, 0xDA, 0xFE, 0xF9, 0x3E, 0x00, 0x00,  // `j...>..
            /* 0028 */  0x20, 0x2B, 0xE2, 0xFE, 0xF9, 0x3E, 0x00, 0x00,  //  +...>..
            /* 0030 */  0x60, 0x6C, 0xEA, 0xFE, 0xF9, 0x3E, 0x00, 0x00,  // `l...>..
            /* 0038 */  0x20, 0x6A, 0xDA, 0xFE, 0xF9, 0x3E, 0x00, 0x00,  //  j...>..
            /* 0040 */  0x20, 0x6C, 0xEA, 0xFE, 0xF9, 0x3E, 0x00, 0x00,  //  l...>..
            /* 0048 */  0x01, 0x90, 0x01, 0x00, 0x03, 0x00, 0x90, 0x01,  // ........
            /* 0050 */  0x13, 0x00, 0x90, 0x01, 0xE5, 0x0D, 0x01, 0x01,  // ........
            /* 0058 */  0x01, 0x00, 0x00, 0x00, 0xE5, 0x0D, 0x01, 0x03,  // ........
            /* 0060 */  0x00, 0x90, 0xD8, 0x09, 0x11, 0x0A               // ......
        })
        Name (OBUF, Buffer (0x0100){})
        Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
        {
            If ((Arg0 == ToUUID ("4004a400-917d-4cf2-b89c-79b62fd55665")))
            {
                Local0 = ToInteger (Arg2)
                If ((Local0 == Zero))
                {
                    Return (Buffer (0x04)
                    {
                         0x01, 0x00, 0x01, 0x01                           // ....
                    })
                }

                If ((Local0 == 0x18))
                {
                    Return (Unicode ("0"))
                }

                If ((Local0 == 0x10))
                {
                    If ((Arg1 == 0x0300))
                    {
                        Return (MXM3) /* \_SB_.PCI0.PEG0.PEGP.MXM3 */
                    }
                }

                Return (0x80000002)
            }

            If ((Arg0 == ToUUID ("a486d8f8-0bda-471b-a72b-6042a6b5bee0")))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NVOP (Arg0, Arg1, Arg2, Arg3))
            }

            If ((Arg0 == ToUUID ("cbeca351-067b-4924-9cbd-b46b00b86f34")))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NGC6 (Arg0, Arg1, Arg2, Arg3))
            }

            If ((Arg0 == ToUUID ("d4a50b75-65c7-46f7-bfb7-41514cea0244")))
            {
                Return (\_SB.PCI0.PEG0.PEGP.NBCI (Arg0, Arg1, Arg2, Arg3))
            }

            If ((Arg0 == ToUUID ("a3132d01-8cda-49ba-a52e-bc9d46df6b81")))
            {
                \_SB.SKOF = Zero
                Return (\_SB.PCI0.PEG0.PEGP.NVPS (Arg0, Arg1, Arg2, Arg3))
            }

            Return (0x80000001)
        }
    }
}

